--
-- WorkAnimation
-- Specialization for WorkAnimation
--
-- @author      Karol Gruszczyk (MySQly)
-- @version     v1.0
-- @date        11/01/17
-- @history:    v1.0 - Initial version
--

WorkAnimation = {};

function WorkAnimation.prerequisitesPresent(specializations)
    return true
end;

function WorkAnimation:load(xmlFile)
    self.turnedOn = false

    self.counter = 0.0
    self.speed = 0.0
    self.direction = true

    self.animation = getXMLString(self.xmlFile, "vehicle.workAnimation#animName")
    self.maxSpeed = getXMLFloat(self.xmlFile, "vehicle.workAnimation#speed")
end;

function WorkAnimation:delete()
end;

function WorkAnimation:readStream(streamId, connection)
end;

function WorkAnimation:writeStream(streamId, connection)
end;

function WorkAnimation:mouseEvent(posX, posY, isDown, isUp, button)
end;

function WorkAnimation:keyEvent(unicode, sym, modifier, isDown)
end;

function WorkAnimation:update(dt)
    if self:getIsActive() then
        if self.direction then
            self.counter = self.counter + dt * self.speed
            if self.counter > 1.0 then
                self.direction = not self.direction
            end
        else
            self.counter = self.counter - dt * self.speed
            if self.counter < 0.0 then
                self.direction = not self.direction
            end
        end

        self:setAnimationTime(self.animation, self.counter)

        if self.attacherVehicle ~= nil then
            local turnedOn = false
            if self.attacherVehicle.turnOnVehicle ~= nil then
                turnedOn = self.attacherVehicle.turnOnVehicle.isTurnedOn
            elseif self.attacherVehicle.attacherVehicle ~= nil and self.attacherVehicle.attacherVehicle.turnOnVehicle ~= nil then
                turnedOn = self.attacherVehicle.attacherVehicle.turnOnVehicle.isTurnedOn
            end
            if turnedOn then
                self.speed = self.speed + dt * 0.00001
                if self.speed > self.maxSpeed then
                    self.speed = self.maxSpeed
                end
            else
                self.speed = self.speed - dt * 0.00001
                if self.speed < 0.0 then
                    self.speed = 0.0
                end
            end
        end
    end
end;

function WorkAnimation:updateTick(dt)
end;

function WorkAnimation:draw()
end;
